! User-interface definitions for (Moose) INet process, GDMR, Jan. 1988

%conststring(23) INet mailbox name = "INET__USER_REQUESTS"

%recordformat INet user request fm(%record(message fm) system part,
                                   %record(INet user request fm)%name next,
                                   %integer unit, key, code, status, timeout, tag,
                                   %bytename buffer, %integer bytes,
                                   (%record(*)%name INet buffer %c
                                %or %integer peer, interface))

%constinteger dud op       error = -1
%constinteger none free    error = -2
%constinteger timeout      error = -3
%constinteger reset        error = -4
%constinteger bugcheck     error = -5
%constinteger privilege    error = -6
%constinteger exists       error = -7
%constinteger closing      error = -8
%constinteger user timeout error = -9

%conststring(31)%array INet errors(-9 : -1) = %c
      "User timeout",
      "Connection closing",
      "Connection exists",
      "No privilege",
      "Bugcheck",
      "Connection reset",
      "Connection timed out",
      "No free slots",
      "Dud operation"

%constinteger request type = 16_F0

%constinteger TCP request                 = 16_10
%constinteger TCP allocate unit  request  = 16_11;  ! Always valid
%constinteger TCP abort          request  = 16_12;  ! Valid when allocated
%constinteger TCP claim          request  = 16_13;  ! ...
%constinteger TCP claim priv     request  = 16_14;  ! ...
%constinteger TCP open           request  = 16_15;  ! ...
%constinteger TCP send           request  = 16_16;  ! Valid when open
%constinteger TCP close          request  = 16_17;  ! ...
%constinteger TCP receive        request  = 16_18;  ! ...
%constinteger TCP first          request  = TCP allocate unit request
%constinteger TCP last           request  = TCP receive request

%constinteger UDP request                 = 16_20
%constinteger UDP allocate unit  request  = 16_21;  ! Always valid
%constinteger UDP forget context request  = 16_22;  ! Valid when allocated
%constinteger UDP claim          request  = 16_23;  ! ...
%constinteger UDP claim priv     request  = 16_24;  ! ...
%constinteger UDP define context request  = 16_25;  ! ...
%constinteger UDP query context  request  = 16_26;  ! Valid when open
%constinteger UDP data           request  = 16_27;  ! ...
%constinteger UDP receive        request  = 16_28;  ! ...
%constinteger UDP first          request  = UDP allocate unit request
%constinteger UDP last           request  = UDP receive request

%constinteger ICMP request                = 16_30
%constinteger ICMP ping          request  = 16_31
%constinteger ICMP timestamp     request  = 16_32
%constinteger ICMP first         request  = ICMP ping request
%constinteger ICMP last          request  = ICMP timestamp request

%end %of %file
