! IE

! A keypad editor

! RMM October 1982

%constant %integer abort = 15
%constant %string (15) IE Version = "4.1"

{options for the editor}
%constant %integer silent             = 2_00000001,     {print no file messages}
                   confirm            = 2_00000010,
                   deaf               = 2_00000100,
                   Reset Heap         = 2_00001000,
                   Recover Edit       = 2_00010000,
                   Ignore Differences = 2_00100000,
                   Adopt Defaults     = 2_01000000

%external %routine %spec IE editor %alias "IE_EDITOR" %c
                                   (%string (255) in file, out file,
                                    %integer window top, window bottom,
                                    %integer %name start line, start pos,
                                    %string (255) profile,
                                                  keyboard,
                                    %integer options)

%external %routine %spec Receive Broadcast %alias "IE_BROADCAST" %c
                                           (%string (255) Message)
%external %integer %spec Main Buffer Changed %alias "IE_CHANGED_FLAG"

%external %string (255) %function %spec Default Profile %alias "IE_DEF_PRO"
%external %string (255) %function %spec Default Keyboard %alias "IE_DEF_KEY"
%external %string (31) %spec Journal File %alias "IE_J_FILE"
%external %string (255) %function %spec Default Journal %alias "IE_DEF_JOU"

{Stuff for preloading buffers}

%record %format Preload fm (%string (32) Buffer Name,
                            %string (255) File Name,
                            %record (Preload fm) %name Next)
%external %record (Preload fm) %name %spec Preloads %alias "IE_PRELOADS"

%end %of %file
