! Include file for interfacing to Ethernet driver
! for board based on Intel 82586

%option "-nons"

%externalbytespec ether fifolim, ether savbf, ether atloc,
{for SET MODES}   ether intloop, ether extloop, ether prom

%externalintegerspec commands executed, commands failed,
{statistics}         frames received, frames lost, frames discarded,
                     extra buffers, buffer low water, desc low water,
                     tx restarts, rx restarts,
                     crc errs, aln errs, rsc errs, ovr errs

%externalbytearraynamespec ether transmit dest(1:6)
%externalbytearraynamespec ether transmit data(1:1514)
%externalhalfspec ether transmit type
%externalhalfspec ether transmit size

%externalbytearraynamespec ether receive dest(1:6)
%externalbytearraynamespec ether receive source(1:6)
%externalbytearraynamespec ether receive data(1:1514)
%externalhalfspec ether receive size
%externalhalfspec ether receive type

%externalroutinespec ether multicast address(%bytearrayname a(1:6))
%externalroutinespec ether local address(%bytearrayname a(1:6))
%externalroutinespec ether set modes

%externalroutinespec ether startup(%bytearrayname local address(1:6))
%externalroutinespec ether shutdown

%externalroutinespec ether accept type range(%half mintype,maxtype)
%externalroutinespec ether ignore type range(%half mintype,maxtype)

%externalroutinespec ether transmit frame
%externalpredicatespec ether frame received(%half type)
