link(a,b,c,90).
link(b,c,d,90).
link(c,d,a,90).
link(d,a,b,90).
link(e,f,g,60).
link(f,g,e,60).
link(g,e,f,60).

box(A, B, C, D) :- link(A, B, C, 90),
                   link(B, C, A, 90),
                   link(C, D, B, 90),
                   link(D, A, C, 90).

link(A, C, B, 45) :- box(A, B, C, _);
                     box(_, A, B, C);
                     box(C, _, A, B);
                     box(B, C, _, A).

link(B, C, A, 45) :- link(A, C, B, 45).

triangle(A, B, C) :- link(A, B, K),
                     link(B, C, L),
                     link(C, A, M),
                     V is K + L + M,
                     V = 180.
