fifo    equ    #$60000
fitop   equ    #$61000
rambot  equ    #$10000
ramtop  equ    #$1cffe
led     equ    #$70000
testv   equ    #$00f5
off     equ    #$000f
green   equ    #$000e
red     equ    #$000d
both    equ    #$000c
*
        org    $1000
start:  move.l led,a2
        move.w off,(a2)    * clear leds
*
        move.l fifo,a1
        move.w green,(a2)
rmtst:  move.l a1,d1        * move address value to data register
        move.w d1,(a1)+
        cmp.l fitop,a1
        bne rmtst
*
        move.w both,(a2)

loop:   jmp    loop         
error:  jmp    error
*
berr:   move.w red,(a2)
berr1   jmp    berr1        *IN CASE OF BUSERROR
adderr: move.w red,(a2)
aderr1: jmp    aderr1      *IN CASE OF ADDRERROR
*
        org    $0
        dc.l   $1fff0       *SETUP STACK POINTER
        dc.l   start        *START OF PROGRAM
        dc.l   berr         *BUSERROR VECTOR
        dc.l   adderr       *ADDRERROR VECTOR
        END
