! Gp routines
%external %integer %fn %spec peekw(%integer address)
%external %integer %fn %spec peekb(%integer address)
%external %routine %spec pokew(%integer address, data)
%external %routine %spec pokeb(%integer address, data)
%external %routine %spec wi bot(%integer %name address, %integer data)
%external %routine %spec wi top(%integer %name address, %integer data)
%external %routine %spec write palette(%integer n,status,r,g,b)
%external %routine %spec await dp poll
%external %routine %spec await gp poll
%external %routine %spec abs mov (%integer x,y)
%external %routine %spec arc exclusion (%integer dxmin,dymin,dxmax,dymax,radius)
%external %routine %spec arc inclusion (%integer dxmin,dymin,dxmax,dymax,radius)
%external %routine %spec bit blt (%integer sx,sy,dx,dy)
%external %routine %spec bit blt m (%integer srcaddr,sxmax,symax,sx,sy,dx,dy)
%external %routine %spec call (%integer address)
%external %routine %spec char opaque(%integer strptr, chars)
%external %routine %spec char transparent (%integer strptr, chars)
%external %routine %spec circle (%integer radius)
%external %routine %spec def bitmap(%integer address,xmax,ymax,bpp)
%external %routine %spec def char orient (%integer path, rotation)
%external %routine %spec def char set word (%integer fontaddr)
%external %routine %spec def char set byte (%integer fontaddr)
%external %routine %spec def char space (%integer space)
%external %routine %spec def clip rect (%integer xmin,ymin,xmax,ymax)
%external %routine %spec def colors (%integer f, b)
%external %routine %spec def logical op (%integer bitmask,fcode)
%external %routine %spec def texture opaque (%integer pattern)
%external %routine %spec def texture transparent(%integer pattern)
%external %routine %spec dump reg(%integer address,register)
%external %routine %spec enter pick
%external %routine %spec exit pick
%external %routine %spec halt
%external %routine %spec incr point(%integer address,number)
%external %routine %spec intr gen
%external %routine %spec line rel(%integer dx,dy)
%external %routine %spec link(%integer address)
%external %routine %spec load reg(%integer address,register)
%external %routine %spec nop
%external %routine %spec point(%integer dx,dy)
%external %routine %spec polygon(%integer address,number)
%external %routine %spec polyline(%integer address,number)
%external %routine %spec rect(%integer dx,dy)
%external %routine %spec rel mov(%integer dx,dy)
%external %routine %spec return
%external %routine %spec scan lines(%integer address,number)

! *****************************************************************
! Data flow routines

%external %routine %spec turn execution off
%external %routine %spec turn execution on
%external %routine %spec open gcmb main
%external %routine %spec close gcmb main
%external %integer %fn %spec open gcmb sub
%external %routine %spec close gcmb sub
%external %routine %spec del gcmb sub(%integer address)
%external %routine %spec gp init

! ****************************************************************
! DP routines

%external %routine %spec load strip header(%integer lines,tiles,last)
%external %routine %spec load tile(%integer bmapw,addr,bpp,
                                            start,stop,fetch,tblr,z,f)
%external %routine %spec dploadreg(%integer address,register)
%external %routine %spec dpdumpreg(%integer address,register)
%external %routine %spec dploadall(%integer address)
%external %routine %spec dpdumpall(%integer address)
%external %routine %spec zoom(%integer x,y)
%external %routine %spec cursor on
%external %routine %spec cursor off
%external %routine %spec cursor type(%integer t)
%external %routine %spec cursor(%integer x,y)

! ****************************************************************
! Memory management routines

%external %integer %fn %spec load string(%string(255) %name txt)
%external %integer %fn %spec open array
%external %routine %spec load poly(%integer dx,dy)
%external %routine %spec load scan line(%integer dx,dy,deltax)
%external %routine %spec load incr point(%integer inc)

! ***************************************************************
! Font handling routines

%external %routine %spec load font (%string(255) fname, %integer %name faddr)
