!
!
!
!     CONSTS.INC                    APMTEL CONSTANTS FOR DATABASE     AN 2/3/88
!
!
!

%constinteger record size        =1024
%constinteger page size          =960
%constinteger header size        =record size - page size
%constinteger used               =16_ff
%constinteger free               =0

! RECORD SIZE is the length of each record in the APMTEL database
! It is made up as follows :-
!
!     byte offset            contents
!     -----------            --------
!        0                      USED         (16_ff=IN USE, 0=Free)
!        1                      Channel      (1 byte channel number)
!        2-5                    FILE ID      (7 digit number for ID)
!        6-21                   DATE STAMP   (15 Character date info)
!        22-64                  Comments     (String of comments for CH5)
!        65-1024                PAGE         (The bytes that make up the page)
!

%recordformat ENTRY FM(%byte usage,                      {Usage byte
                       %byte channel,                   {The channel its pulled from
                       %integer page no,                { page number
                       %bytearray reserved(0:57),
                       %string(15) datestamp,
                       %bytearray page(0:23,0:39))


%constinteger usage offset = 0
%constinteger channel offset=1
%constinteger page no lo offset=3
%constinteger page no hi offset=2
%constinteger date stamp offset=5
%constinteger comments offset = 21
%constinteger page offset = 64


%endoffile
