{ EDWIN constant definitions }                         %end %of %list

! Colours
%constant %byte Min Edwin Colour =  0
%constant %byte Video Black      =  0, Video White = 1
%constant %byte Blank            =  0
%constant %byte Black            =  1
%constant %byte Blue             =  2
%constant %byte Green            =  3
%constant %byte Red              =  4
%constant %byte Magenta          =  5
%constant %byte Yellow           =  6
%constant %byte Cyan             =  7
%constant %byte Brown            =  8
%constant %byte Orange           =  9
%constant %byte Violet           = 10
%constant %byte Max Edwin Colour = 10

%constant %string(11) %array Edwin Colours (Min Edwin Colour:Max Edwin Colour) =
   "BACKGROUND", "DEFAULT", "BLUE", "GREEN", "RED", "MAGENTA", "YELLOW",
   "CYAN", "BROWN", "ORANGE", "VIOLET"

! Colour Modes
%constant %byte Replace Mode = 0
%constant %byte And Mode     = 1
%constant %byte Or Mode      = 2
%constant %byte Xor Mode     = 3
%constant %byte Invert Mode  = 4

! Fill and Line styles
%constant %byte Min Edwin      Style = -16
%constant %byte N Minus Logo    Fill = -16
%constant %byte P Minus Logo    Fill = -15
%constant %byte N Plus Logo     Fill = -14
%constant %byte P Plus Logo     Fill = -13
%constant %byte Half Tone 2     Fill = -12
%constant %byte Half Tone       Fill = -11
%constant %byte Brick           Fill = -10
%constant %byte Checker         File = -9
%constant %byte Stipple         Fill = -8
%constant %byte Grid            Fill = -7
%constant %byte Cross hatch     Fill = -6
%constant %byte Diagonal        Fill = -5
%constant %byte Back Diagnonal  Fill = -4
%constant %byte Vertical Line   Fill = -3
%constant %byte Horizontal Line Fill = -2
%constant %byte Solid           Fill = -1
%constant %byte Solid                =  1
%constant %byte Outline              =  0
%constant %byte normal         Lines =  0
%constant %byte dotted         Lines =  1
%constant %byte chain          Lines =  2
%constant %byte short dashed   Lines =  3
%constant %byte long dashed    Lines =  4
%constant %byte Max Edwin      Style =  4

%constant %string(10) %array Edwin Styles (Min Edwin Style:Max Edwin Style) =
    "N-LOGO",    "P-LOGO",   "N+LOGO",     "P+LOGO",
    "HALFTONE",  "HALFTONE2","BRICK",      "CHECKER",
    "STIPPLE",   "GRID",     "CROSSHATCH", "/DIAGONAL", 
    "\DIAGONAL", "VERTICAL", "HORIZONTAL", "SOLID", 
    "NORMAL",    "DOTTED",   "CHAIN",      "SHORTDASH",     "LONGDASH"

! Character quality
%constant %byte hardware text = 0
%constant %byte software text = 1

! Character Mirroring
%constant %byte No Mirroring        = 0
%constant %byte Mirror in X axis    = 1
%constant %byte Mirror in Y axis    = 2
%constant %byte Mirror in both axes = 3

! Modes (Aspect Ratio)
%constant %byte on  = 1, off = 0

! Marker types
%constant %byte Min Edwin            Marker = 0
%constant %byte point                marker = 0
%constant %byte octagon              marker = 1
%constant %byte square               Marker = 2
%constant %byte triangle             Marker = 3
%constant %byte transformation point Marker = 4
%constant %byte flag point           Marker = 5
%constant %byte visual centroid      Marker = 6
%constant %byte right arrow          Marker = 7
%constant %byte left arrow           Marker = 8
%constant %byte up arrow             Marker = 9
%constant %byte down arrow           Marker = 10
%constant %byte Star                 Marker = 11
%constant %byte Diamond              Marker = 12
%constant %byte Max Edwin            Marker = 12

%constant %string(8)  %array Edwin Markers (Min Edwin Marker:Max Edwin Marker) =
   "POINT",  "OCTAGON",  "SQUARE",  "TRIANGLE", "CROSS", "FLAG", "PLUS",
   "RIGHT",  "LEFT",     "UP",      "DOWN",     "STAR",  "DIAMOND"

! Device numbers (from device data record)
%constant %byte Tektronix   = 1
%constant %byte Charles     = 2
%constant %byte Hp plotter  = 3
%constant %byte Calcomp     = 4
%constant %byte Printronix  = 5
%constant %byte Terminal    = 6
%constant %byte Hp 2648     = 7
%constant %byte Westward    = 8
%constant %byte Sigma       = 9
%constant %byte GiGi        = 10
%constant %byte APM Level 1 = 10
%constant %byte BBC Micro   = 11
%constant %byte APM Level 2 = 11
%constant %byte X5A         = 12
%constant %byte GP300       = 13
%constant %byte Laser       = 14
%constant %byte Colour Tek  = 15
%constant %byte Network GP  = 16
%constant %byte Network HP  = 17
%constant %byte VT100       = 18
%constant %byte Versatec    = 19

%end %of %file
