{ EDWIN constant definitions }

! Colours
%constant %byte Video Black = 0, Video White = 1
%constant %byte Blank       = 0
%constant %byte Black       = 1
%constant %byte Blue        = 2
%constant %byte Green       = 3
%constant %byte Red         = 4
%constant %byte Purple      = 5
%constant %byte Yellow      = 6
%constant %byte Lime        = 7
%constant %byte Brown       = 8
%constant %byte Turquoise   = 9

! Colour Modes
%constant %byte Replace Mode = 0
%constant %byte And Mode     = 1
%constant %byte Or Mode      = 2
%constant %byte Xor Mode     = 3
%constant %byte Invert Mode  = 4

! Line styles
%constant %byte normal       lines = 0
%constant %byte dotted       lines = 1
%constant %byte chain        lines = 2
%constant %byte short dashed lines = 3
%constant %byte long dashed  lines = 4

! Character quality
%constant %byte hardware text = 0
%constant %byte software text = 1

! Modes (Aspect Ratio)
%constant %byte on  = 1, off = 0

! Constants for shade modes
%constant %integer OUTLINE = 0
%constant %integer SOLID   = 1

! Marker types
%constant %byte point                marker = 0
%constant %byte octagon              marker = 1
%constant %byte square               marker = 2
%constant %byte triangle             marker = 3
%constant %byte transformation point marker = 4
%constant %byte flag point           marker = 5
%constant %byte visual centroid      marker = 6
%constant %byte right arrow          marker = 7
%constant %byte left arrow           marker = 8
%constant %byte up arrow             marker = 9
%constant %byte down arrow           marker = 10

! Device numbers (from device data record)
%constant %byte Tektronix   = 1
%constant %byte Charles     = 2
%constant %byte Hp plotter  = 3
%constant %byte Calcomp     = 4
%constant %byte Printronix  = 5
%constant %byte Terminal    = 6
%constant %byte Hp 2648     = 7
%constant %byte Westward    = 8
%constant %byte Sigma       = 9
%constant %byte GiGi        = 10
%constant %byte APM Level 1 = 10
%constant %byte BBC Micro   = 11
%constant %byte APM Level 2 = 11
%constant %byte X5A         = 12
%constant %byte GP300       = 13

%end %of %file
