/*
**	APM Font file format
**
**	FDC, 10/5/84
*/

struct fontinfo		/* file header */
{
	short	firstchar, lastchar;	/* range of characters defined */
	int	dimtab_offset;		/* byte offset of dimension table */
	int	raster_offset[256];	/* byte offset of raster data */
					/* (only 0 .. last-first defined) */
};

struct diminfo		/* dimension table entry */
{
	short	HSize;			/* horizontal size in pixels */
	short	VSize;			/* vertical size in pixels */
	short	HOffs;			/* horizontal offset in pixels */
	short	VOffs;			/* vertical offset in pixels */
	short	HIncr;			/* horizontal cursor increment */
	short	VIncr;			/* vertical cursor increment */
};

struct rasterinfo	/* character bit-map */
{
	short	DimIndex;		/* Index into dimension table */
	unsigned short	raster[1];	/* top left pixel row */
};
