%const %integer MAX PARTITION = 7
! FS administration database record format.

%recordformat admin fm( %c
  %string (7) Id,               {  8 Directory name}
  ((%string (35) Prenames,      { 36 Prenames of directory owner}
  %string (15) Surname) %or  %c
  %string (51) Description),    {    or directory description}
  %string (15) Supervisor,      { 16 Surname of Supervisor if appropriate}
  %shortinteger Group,          {  2 Note (#1)}
  Fs,                           {  2 map of filestores on which name exists (#2)}
  %string (9) Created,          {  8 date created}
  Delete,                       {  8 date after which directory may be discarded}
  %string (27) Mail addr)       { 28 mail address}
{ 16 Surname of directory Owner}

! #1 Groups:
%constinteger unkn grp=0, essential grp=1, system grp=2, staff grp=3,
   postgrad grp=4, cs4grp=5, cs3grp=6, cs2grp=7, cs1grp=8, is1grp=9, visitor grp=10,
   public grp=11, other grp=12, ercc grp=13, msc grp=14, lattice grp=15,
   dummy last grp=16
%conststring(15) %array grp names(0:dummy last grp) = %c
"Unknown", "Essential", "Systems", "Staff", "PG", "CS4", "CS3", "CS2",
"CS1", "IS1", "Visitors", "Public", "Other Depts.", "ERCC", "MSC", "Lattice", ""
! 0: Unknown                          ! 1: Essential systems directories
! 2: Additional Systems directories   ! 3: Staff
! 4: Postgrad                         ! 5: CS4
! 6: CS3                              ! 7: CS2
! 8: CS1                              ! 9: IS1
!10: Visitors                         !11: Public directories
!12: Other Departments                !13: ERCC
!14: MSC

%constinteger trusted bit = 15,
   ex bit = 14, laser bit = 13, fem bit = 12, dummy last prefix = 11
%conststring (7) %array pref names(dummy last prefix:15) = %c
"", "Female", "Lasered", "Ex", "Trusted"

!Bit 15: "Trusted" bit                !Bit 14: "Ex-" bit
!Bit 13: Laser printer bit            !Bit 12: Female Bit

! #2: FS accredited
%constinteger alpha acc   = 16_01, bravo acc   = 16_02, charlie acc = 16_04,
              portable acc= 16_08, vax acc     = 16_10, old acc     = 16_20

%conststring (16) adminfile = "managr:admin.dat"
%conststring (16) adminold  =        "admin.old"
%endoffile
