{ EDWIN Geometric utility routines added }                        %end %of %list

! Set up routines
%external %routine %spec SET WIRE MODE  %alias "EDWIN_SET_WIRE_MODE"  (%integer MODE)
%external %routine %spec SET COLOUR MAP %alias "EDWIN_SET_COLOUR_MAP" (%integer ADR, RED, BLUE, GREEN)

! Constants for wire modes
%constant %integer FLAT ENDS = 0
%constant %integer ROUND ENDS = 1
%constant %integer EXTENDED ENDS = 2

! Drawing routines
%external %routine %spec ARC            %alias "EDWIN_ARC"        (%integer OX, OY, RAD, START ANG, END AND)
%external %routine %spec SECTOR         %alias "EDWIN_SECTOR"     (%integer OX, OY, RAD, START ANG, END AND)
%external %routine %spec CIRCLE         %alias "EDWIN_CIRCLE"     (%integer RAD)
%external %routine %spec RECTANGLE      %alias "EDWIN_RECTANGLE"  (%integer XL, YL, XU, YU)
%external %routine %spec BOX            %alias "EDWIN_BOX"        (%integer L, W, %record (POINTFM) %name C, D)
%external %routine %spec WIRE           %alias "EDWIN_WIRE"       (%integer W, NP,
                                 %record (POINTFM) %array %name P)
%external %routine %spec POLYGON        %alias "EDWIN_POLYGON"    (%integer NP,
                                   %record (POINTFM) %array %name P)

%end %of %file
