!!%external %routine %spec Upper Case %alias "USE_UpCase" (%string(*) %name it)
!!Use TO UPPER
!!%external %routine %spec Lower Case %alias "USE_LowCase" (%string(*) %name it)
!!Use TO LOWER

%external %integer %fn %spec Find Index %alias "USE_FindIdx" (%string (7) who)

!!%external %string (6) %fn %spec Current Directory %alias "USE_CurrDir"
!!Use version in INC:FSUTIL.IMP

!!%external %string (6) %fn %spec Current User %alias "USE_CurrUser"
!!Use version in INC:FSUTIL.IMP

%external %string (2) %fn %spec Hex 2 %alias "USE_Hex2" (%integer xx)

%external %routine %spec Format %alias "USE_Format" (%string (255) Line)

!!%external %predicate %spec Matches %alias "USE_Matches" (%string (*) %name s, p)
!!Use version in INC:FSUTIL.IMP

%external %routine %spec Announce %alias "USE_Announce" %c
   (%string (80) What, %integer Count)

%external %integer %fn %spec Minimum Difference %alias "USE_MinDiff" %c
   (%string (31) One, Two)

%record %format User Fm (%string (6) User Name, Directory,
                         %string (21) Login Time,
                         %byte Uno, Pno, Flags, Location,
                         %short Difference)

%external %routine %spec Get Unos From FS %alias "USE_GFsUnos" %c
   (%record (User Fm) %array %name Users (1:*),
    %integer %name Number of Users,
    %integer %name Number of Internal Copies)

%end %of %file
