{ EDWIN Internal Code Deffinitions }                   %end %of %list

! Device Driver commands
%constant %integer dev initialise = 0
%constant %integer dev terminate  = 1
%constant %integer dev update     = 2
%constant %integer dev newframe   = 3
%constant %integer dev move       = 4
%constant %integer dev line       = 5
%constant %integer dev char       = 6
%constant %integer dev attribute  = 7
%constant %integer dev low wb     = 8
%constant %integer dev high wb    = 9
%constant %integer dev code 10    = 10
%constant %integer dev code 11    = 11
%constant %integer dev low box    = 12
%constant %integer dev high box   = 13
%constant %integer dev circle     = 14
%constant %integer dev code 15    = 15
%constant %integer MAX COM        = 15   { device commands from 0 to MAX COM }

! Attribute numbers
%constant %integer att colour       = 0
%constant %integer att line style   = 1
%constant %integer att char size    = 2
%constant %integer att char rot     = 3
%constant %integer att char quality = 4
%constant %integer att char font    = 5
%constant %integer att char slant   = 6
%constant %integer att marker size  = 7
%constant %integer att speed        = 8
%constant %integer att colour mode  = 9
%constant %integer att shade mode   = 10
%constant %integer att chord step   = 11
%constant %integer att char mirror  = 12
%constant %integer att maximum      = 12

! PDF command codes
%constant %integer pdf line abs   = 0
%constant %integer pdf move abs   = 1
%constant %integer pdf mark abs   = 2
%constant %integer pdf line rel   = 3
%constant %integer pdf move rel   = 4
%constant %integer pdf mark rel   = 5
%constant %integer pdf code 6     = 6
%constant %integer pdf code 7     = 7
%constant %integer pdf window     = 8
%constant %integer pdf character  = 9
%constant %integer pdf attribute  = 10
%constant %integer pdf newframe   = 11
%constant %integer pdf terminate  = 12
%constant %integer pdf code 13    = 13
%constant %integer pdf shape esc  = 14
%constant %integer pdf gen attrib = 15

! Other internal codes
%constant %integer True = 1, False = 0
%constant %integer default  = 0    { Attribute settings }
%constant %integer disabled = -1   { Value for clipping, storing, viewing }
