%option "-nons-nowarn"
%begin

%bytearray epic(0:128*512)

%bytearray     pic(0:65535)
%bytearray     image(0:128*512)

{ Grab frame command options. }
%constinteger  noalt=32,
               narrow=16,
               eightbit=8,
               twoarray=4,
               alt=0,
               wide=0,
               sevenbit=0,
               onearray=0

%externalroutinespec grab frame(%integer command, exposure, address,
                                                  %integername rows,cols,bytes)
%externalroutinespec display frame(%integer x,y,%bytename line)
%externalroutinespec transform(%bytearrayname pic(0:65535),
                               %bytearrayname image(0:128*512))
%externalroutinespec pulse(%integer msec)
%externalroutinespec move axes(%integer mdp, %integerarray pulses(0:5))
%externalroutinespec initialise motors   {Switch all motors off}
%externalroutinespec open interface
%externalroutinespec fillimage(%bytearrayname image(0:128*512))
%externalroutinespec camera
%externalroutinespec clear frame(%bytename base)
%externalroutinespec dump bitmap(%bytearrayname image(0:128*512),
                                                              %string(255) file)
%endoffile

